package au.id.mcauliffe.obscurer;
/* For license, see license.txt */

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Implements an MD5 algorithm for obscuring Strings.
 * @version 1.0.1
 */
final class Md5Algorithm implements ObscuringAlgorithm
{
    private String ALGORITHM = "MD5";
    public Md5Algorithm()
    {
        // test creation of digest to fire exception early if there is a problem
        try
        {
            MessageDigest digest = MessageDigest.getInstance(ALGORITHM);
        }
        catch (NoSuchAlgorithmException error)
        {
            throw new ObscurerInitialisationException(
                    ObscuringMethod.MD5_HASH,error);
        }
    }
    
    public String obscure(String input) throws ObscurerException
    {
        MessageDigest digest = null;
        try
        {
            digest = MessageDigest.getInstance(ALGORITHM);
        }
        catch (NoSuchAlgorithmException error)
        {
            throw new ObscurerException(
                    ObscuringMethod.MD5_HASH,error);
        }
        
        digest.update(input.getBytes());
        byte[] output = digest.digest();
        return ByteConverter.byteToHex(output);
    }
    
}
