package au.id.mcauliffe.obscurer;

/* For license, see license.txt */

/** Represents a problem executing an algorithm of an
 *  obscurer.  This may be a temporary problem.
 */
public class ObscurerException extends Exception
{
    public final ObscuringMethod method;
    
    /** Creates a new exception relating to the given method.
     *  @param method the method who's algorithm's execution failed
     *  @param cause the causing exception, null if none
     */
    public ObscurerException(ObscuringMethod method, 
                             Throwable cause)
    {
        super("The method "+method+" failed to execute. "+cause.getMessage());
        this.method = method;
    }
}
