package au.id.mcauliffe.obscurer;

/* For license, see license.txt */

/** Represents a problem initialising an algorithm of an
 *  obscurer. Generally means that this algorithm cannot be used
 *  in the near future (possibly not this invocation of the JVM,
 *  possibly never).
 */
public class ObscurerInitialisationException extends RuntimeException
{
    public final ObscuringMethod method;
    
    /** Creates a new exception relating to the given method.
     *  @param method the method who's algorithm's initialisation failed
     *  @param cause the causing exception, null if none
     */
    public ObscurerInitialisationException(ObscuringMethod method,
                                           Throwable cause)
    {
        super("The method "+method+" failed to initialise. "+cause.getMessage());
        this.method = method;
    }
}
