package au.id.mcauliffe.obscurer;

/* For license, see license.txt */

/** A algorithm that can repeatably obscure strings.*/
interface ObscuringAlgorithm
{
    /** Obscures the input using this algorithm.
     *  @param input the string to obscure
     *  @return the obscured version of the given string 
     *  @throws ObscurerException if the obscuring algorithm cannot be run
     */
    public String obscure(String input) throws ObscurerException;
}
